=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.2.3

=end

require 'cgi'

module PulpCertguardClient
  class ContentguardsRhsmApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a rhsm cert guard
    # RHSMCertGuard API Viewsets.
    # @param certguard_rhsm_cert_guard [CertguardRHSMCertGuard] 
    # @param [Hash] opts the optional parameters
    # @return [CertguardRHSMCertGuardResponse]
    def create(certguard_rhsm_cert_guard, opts = {})
      data, _status_code, _headers = create_with_http_info(certguard_rhsm_cert_guard, opts)
      data
    end

    # Create a rhsm cert guard
    # RHSMCertGuard API Viewsets.
    # @param certguard_rhsm_cert_guard [CertguardRHSMCertGuard] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CertguardRHSMCertGuardResponse, Integer, Hash)>] CertguardRHSMCertGuardResponse data, response status code and response headers
    def create_with_http_info(certguard_rhsm_cert_guard, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentguardsRhsmApi.create ...'
      end
      # verify the required parameter 'certguard_rhsm_cert_guard' is set
      if @api_client.config.client_side_validation && certguard_rhsm_cert_guard.nil?
        fail ArgumentError, "Missing the required parameter 'certguard_rhsm_cert_guard' when calling ContentguardsRhsmApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/contentguards/certguard/rhsm/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(certguard_rhsm_cert_guard) 

      # return_type
      return_type = opts[:return_type] || 'CertguardRHSMCertGuardResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentguardsRhsmApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a rhsm cert guard
    # RHSMCertGuard API Viewsets.
    # @param certguard_r_h_s_m_cert_guard_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete(certguard_r_h_s_m_cert_guard_href, opts = {})
      delete_with_http_info(certguard_r_h_s_m_cert_guard_href, opts)
      nil
    end

    # Delete a rhsm cert guard
    # RHSMCertGuard API Viewsets.
    # @param certguard_r_h_s_m_cert_guard_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_with_http_info(certguard_r_h_s_m_cert_guard_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentguardsRhsmApi.delete ...'
      end
      # verify the required parameter 'certguard_r_h_s_m_cert_guard_href' is set
      if @api_client.config.client_side_validation && certguard_r_h_s_m_cert_guard_href.nil?
        fail ArgumentError, "Missing the required parameter 'certguard_r_h_s_m_cert_guard_href' when calling ContentguardsRhsmApi.delete"
      end
      # resource path
      local_var_path = '{certguard_r_h_s_m_cert_guard_href}'.sub('{' + 'certguard_r_h_s_m_cert_guard_href' + '}', CGI.escape(certguard_r_h_s_m_cert_guard_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentguardsRhsmApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List rhsm cert guards
    # RHSMCertGuard API Viewsets.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name name
    # @option opts [String] :name__in name__in
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [InlineResponse200]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List rhsm cert guards
    # RHSMCertGuard API Viewsets.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name name
    # @option opts [String] :name__in name__in
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(InlineResponse200, Integer, Hash)>] InlineResponse200 data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentguardsRhsmApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/contentguards/certguard/rhsm/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__in'] = opts[:'name__in'] if !opts[:'name__in'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'InlineResponse200' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentguardsRhsmApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a rhsm cert guard
    # RHSMCertGuard API Viewsets.
    # @param certguard_r_h_s_m_cert_guard_href [String] 
    # @param patchedcertguard_rhsm_cert_guard [PatchedcertguardRHSMCertGuard] 
    # @param [Hash] opts the optional parameters
    # @return [CertguardRHSMCertGuardResponse]
    def partial_update(certguard_r_h_s_m_cert_guard_href, patchedcertguard_rhsm_cert_guard, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(certguard_r_h_s_m_cert_guard_href, patchedcertguard_rhsm_cert_guard, opts)
      data
    end

    # Update a rhsm cert guard
    # RHSMCertGuard API Viewsets.
    # @param certguard_r_h_s_m_cert_guard_href [String] 
    # @param patchedcertguard_rhsm_cert_guard [PatchedcertguardRHSMCertGuard] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CertguardRHSMCertGuardResponse, Integer, Hash)>] CertguardRHSMCertGuardResponse data, response status code and response headers
    def partial_update_with_http_info(certguard_r_h_s_m_cert_guard_href, patchedcertguard_rhsm_cert_guard, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentguardsRhsmApi.partial_update ...'
      end
      # verify the required parameter 'certguard_r_h_s_m_cert_guard_href' is set
      if @api_client.config.client_side_validation && certguard_r_h_s_m_cert_guard_href.nil?
        fail ArgumentError, "Missing the required parameter 'certguard_r_h_s_m_cert_guard_href' when calling ContentguardsRhsmApi.partial_update"
      end
      # verify the required parameter 'patchedcertguard_rhsm_cert_guard' is set
      if @api_client.config.client_side_validation && patchedcertguard_rhsm_cert_guard.nil?
        fail ArgumentError, "Missing the required parameter 'patchedcertguard_rhsm_cert_guard' when calling ContentguardsRhsmApi.partial_update"
      end
      # resource path
      local_var_path = '{certguard_r_h_s_m_cert_guard_href}'.sub('{' + 'certguard_r_h_s_m_cert_guard_href' + '}', CGI.escape(certguard_r_h_s_m_cert_guard_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(patchedcertguard_rhsm_cert_guard) 

      # return_type
      return_type = opts[:return_type] || 'CertguardRHSMCertGuardResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentguardsRhsmApi#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a rhsm cert guard
    # RHSMCertGuard API Viewsets.
    # @param certguard_r_h_s_m_cert_guard_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [CertguardRHSMCertGuardResponse]
    def read(certguard_r_h_s_m_cert_guard_href, opts = {})
      data, _status_code, _headers = read_with_http_info(certguard_r_h_s_m_cert_guard_href, opts)
      data
    end

    # Inspect a rhsm cert guard
    # RHSMCertGuard API Viewsets.
    # @param certguard_r_h_s_m_cert_guard_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(CertguardRHSMCertGuardResponse, Integer, Hash)>] CertguardRHSMCertGuardResponse data, response status code and response headers
    def read_with_http_info(certguard_r_h_s_m_cert_guard_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentguardsRhsmApi.read ...'
      end
      # verify the required parameter 'certguard_r_h_s_m_cert_guard_href' is set
      if @api_client.config.client_side_validation && certguard_r_h_s_m_cert_guard_href.nil?
        fail ArgumentError, "Missing the required parameter 'certguard_r_h_s_m_cert_guard_href' when calling ContentguardsRhsmApi.read"
      end
      # resource path
      local_var_path = '{certguard_r_h_s_m_cert_guard_href}'.sub('{' + 'certguard_r_h_s_m_cert_guard_href' + '}', CGI.escape(certguard_r_h_s_m_cert_guard_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'CertguardRHSMCertGuardResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentguardsRhsmApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a rhsm cert guard
    # RHSMCertGuard API Viewsets.
    # @param certguard_r_h_s_m_cert_guard_href [String] 
    # @param certguard_rhsm_cert_guard [CertguardRHSMCertGuard] 
    # @param [Hash] opts the optional parameters
    # @return [CertguardRHSMCertGuardResponse]
    def update(certguard_r_h_s_m_cert_guard_href, certguard_rhsm_cert_guard, opts = {})
      data, _status_code, _headers = update_with_http_info(certguard_r_h_s_m_cert_guard_href, certguard_rhsm_cert_guard, opts)
      data
    end

    # Update a rhsm cert guard
    # RHSMCertGuard API Viewsets.
    # @param certguard_r_h_s_m_cert_guard_href [String] 
    # @param certguard_rhsm_cert_guard [CertguardRHSMCertGuard] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CertguardRHSMCertGuardResponse, Integer, Hash)>] CertguardRHSMCertGuardResponse data, response status code and response headers
    def update_with_http_info(certguard_r_h_s_m_cert_guard_href, certguard_rhsm_cert_guard, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentguardsRhsmApi.update ...'
      end
      # verify the required parameter 'certguard_r_h_s_m_cert_guard_href' is set
      if @api_client.config.client_side_validation && certguard_r_h_s_m_cert_guard_href.nil?
        fail ArgumentError, "Missing the required parameter 'certguard_r_h_s_m_cert_guard_href' when calling ContentguardsRhsmApi.update"
      end
      # verify the required parameter 'certguard_rhsm_cert_guard' is set
      if @api_client.config.client_side_validation && certguard_rhsm_cert_guard.nil?
        fail ArgumentError, "Missing the required parameter 'certguard_rhsm_cert_guard' when calling ContentguardsRhsmApi.update"
      end
      # resource path
      local_var_path = '{certguard_r_h_s_m_cert_guard_href}'.sub('{' + 'certguard_r_h_s_m_cert_guard_href' + '}', CGI.escape(certguard_r_h_s_m_cert_guard_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(certguard_rhsm_cert_guard) 

      # return_type
      return_type = opts[:return_type] || 'CertguardRHSMCertGuardResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentguardsRhsmApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
