=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.2.3

=end

require 'cgi'

module PulpCertguardClient
  class ContentguardsX509Api
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a x509 cert guard
    # X509CertGuard API Viewsets.
    # @param certguard_x509_cert_guard [CertguardX509CertGuard] 
    # @param [Hash] opts the optional parameters
    # @return [CertguardX509CertGuardResponse]
    def create(certguard_x509_cert_guard, opts = {})
      data, _status_code, _headers = create_with_http_info(certguard_x509_cert_guard, opts)
      data
    end

    # Create a x509 cert guard
    # X509CertGuard API Viewsets.
    # @param certguard_x509_cert_guard [CertguardX509CertGuard] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CertguardX509CertGuardResponse, Integer, Hash)>] CertguardX509CertGuardResponse data, response status code and response headers
    def create_with_http_info(certguard_x509_cert_guard, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentguardsX509Api.create ...'
      end
      # verify the required parameter 'certguard_x509_cert_guard' is set
      if @api_client.config.client_side_validation && certguard_x509_cert_guard.nil?
        fail ArgumentError, "Missing the required parameter 'certguard_x509_cert_guard' when calling ContentguardsX509Api.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/contentguards/certguard/x509/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(certguard_x509_cert_guard) 

      # return_type
      return_type = opts[:return_type] || 'CertguardX509CertGuardResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentguardsX509Api#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a x509 cert guard
    # X509CertGuard API Viewsets.
    # @param certguard_x509_cert_guard_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete(certguard_x509_cert_guard_href, opts = {})
      delete_with_http_info(certguard_x509_cert_guard_href, opts)
      nil
    end

    # Delete a x509 cert guard
    # X509CertGuard API Viewsets.
    # @param certguard_x509_cert_guard_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_with_http_info(certguard_x509_cert_guard_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentguardsX509Api.delete ...'
      end
      # verify the required parameter 'certguard_x509_cert_guard_href' is set
      if @api_client.config.client_side_validation && certguard_x509_cert_guard_href.nil?
        fail ArgumentError, "Missing the required parameter 'certguard_x509_cert_guard_href' when calling ContentguardsX509Api.delete"
      end
      # resource path
      local_var_path = '{certguard_x509_cert_guard_href}'.sub('{' + 'certguard_x509_cert_guard_href' + '}', CGI.escape(certguard_x509_cert_guard_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentguardsX509Api#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List x509 cert guards
    # X509CertGuard API Viewsets.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name name
    # @option opts [String] :name__in name__in
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [InlineResponse2001]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List x509 cert guards
    # X509CertGuard API Viewsets.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name name
    # @option opts [String] :name__in name__in
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(InlineResponse2001, Integer, Hash)>] InlineResponse2001 data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentguardsX509Api.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/contentguards/certguard/x509/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__in'] = opts[:'name__in'] if !opts[:'name__in'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'InlineResponse2001' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentguardsX509Api#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a x509 cert guard
    # X509CertGuard API Viewsets.
    # @param certguard_x509_cert_guard_href [String] 
    # @param patchedcertguard_x509_cert_guard [PatchedcertguardX509CertGuard] 
    # @param [Hash] opts the optional parameters
    # @return [CertguardX509CertGuardResponse]
    def partial_update(certguard_x509_cert_guard_href, patchedcertguard_x509_cert_guard, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(certguard_x509_cert_guard_href, patchedcertguard_x509_cert_guard, opts)
      data
    end

    # Update a x509 cert guard
    # X509CertGuard API Viewsets.
    # @param certguard_x509_cert_guard_href [String] 
    # @param patchedcertguard_x509_cert_guard [PatchedcertguardX509CertGuard] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CertguardX509CertGuardResponse, Integer, Hash)>] CertguardX509CertGuardResponse data, response status code and response headers
    def partial_update_with_http_info(certguard_x509_cert_guard_href, patchedcertguard_x509_cert_guard, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentguardsX509Api.partial_update ...'
      end
      # verify the required parameter 'certguard_x509_cert_guard_href' is set
      if @api_client.config.client_side_validation && certguard_x509_cert_guard_href.nil?
        fail ArgumentError, "Missing the required parameter 'certguard_x509_cert_guard_href' when calling ContentguardsX509Api.partial_update"
      end
      # verify the required parameter 'patchedcertguard_x509_cert_guard' is set
      if @api_client.config.client_side_validation && patchedcertguard_x509_cert_guard.nil?
        fail ArgumentError, "Missing the required parameter 'patchedcertguard_x509_cert_guard' when calling ContentguardsX509Api.partial_update"
      end
      # resource path
      local_var_path = '{certguard_x509_cert_guard_href}'.sub('{' + 'certguard_x509_cert_guard_href' + '}', CGI.escape(certguard_x509_cert_guard_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(patchedcertguard_x509_cert_guard) 

      # return_type
      return_type = opts[:return_type] || 'CertguardX509CertGuardResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentguardsX509Api#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a x509 cert guard
    # X509CertGuard API Viewsets.
    # @param certguard_x509_cert_guard_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [CertguardX509CertGuardResponse]
    def read(certguard_x509_cert_guard_href, opts = {})
      data, _status_code, _headers = read_with_http_info(certguard_x509_cert_guard_href, opts)
      data
    end

    # Inspect a x509 cert guard
    # X509CertGuard API Viewsets.
    # @param certguard_x509_cert_guard_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(CertguardX509CertGuardResponse, Integer, Hash)>] CertguardX509CertGuardResponse data, response status code and response headers
    def read_with_http_info(certguard_x509_cert_guard_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentguardsX509Api.read ...'
      end
      # verify the required parameter 'certguard_x509_cert_guard_href' is set
      if @api_client.config.client_side_validation && certguard_x509_cert_guard_href.nil?
        fail ArgumentError, "Missing the required parameter 'certguard_x509_cert_guard_href' when calling ContentguardsX509Api.read"
      end
      # resource path
      local_var_path = '{certguard_x509_cert_guard_href}'.sub('{' + 'certguard_x509_cert_guard_href' + '}', CGI.escape(certguard_x509_cert_guard_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'CertguardX509CertGuardResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentguardsX509Api#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a x509 cert guard
    # X509CertGuard API Viewsets.
    # @param certguard_x509_cert_guard_href [String] 
    # @param certguard_x509_cert_guard [CertguardX509CertGuard] 
    # @param [Hash] opts the optional parameters
    # @return [CertguardX509CertGuardResponse]
    def update(certguard_x509_cert_guard_href, certguard_x509_cert_guard, opts = {})
      data, _status_code, _headers = update_with_http_info(certguard_x509_cert_guard_href, certguard_x509_cert_guard, opts)
      data
    end

    # Update a x509 cert guard
    # X509CertGuard API Viewsets.
    # @param certguard_x509_cert_guard_href [String] 
    # @param certguard_x509_cert_guard [CertguardX509CertGuard] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CertguardX509CertGuardResponse, Integer, Hash)>] CertguardX509CertGuardResponse data, response status code and response headers
    def update_with_http_info(certguard_x509_cert_guard_href, certguard_x509_cert_guard, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentguardsX509Api.update ...'
      end
      # verify the required parameter 'certguard_x509_cert_guard_href' is set
      if @api_client.config.client_side_validation && certguard_x509_cert_guard_href.nil?
        fail ArgumentError, "Missing the required parameter 'certguard_x509_cert_guard_href' when calling ContentguardsX509Api.update"
      end
      # verify the required parameter 'certguard_x509_cert_guard' is set
      if @api_client.config.client_side_validation && certguard_x509_cert_guard.nil?
        fail ArgumentError, "Missing the required parameter 'certguard_x509_cert_guard' when calling ContentguardsX509Api.update"
      end
      # resource path
      local_var_path = '{certguard_x509_cert_guard_href}'.sub('{' + 'certguard_x509_cert_guard_href' + '}', CGI.escape(certguard_x509_cert_guard_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(certguard_x509_cert_guard) 

      # return_type
      return_type = opts[:return_type] || 'CertguardX509CertGuardResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentguardsX509Api#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
